using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace MSISFeed
{
    /// <summary>
    /// Feed subclass for feeds before their format is known
    /// </summary>
    class FeedUnknown: Feed
    {
        public FeedUnknown(int folderId, string address, short itemLimit, XmlReader feedReader)
            : base(folderId, address, itemLimit, feedReader)
        {
            // set feed format
            this.format = FeedFormat.Unknown;
        }

        public FeedUnknown(FeedInterface feed)
            : base(feed)
        { }

        protected override XmlReader AdvanceReaderToItems(XmlReader feedReader)
        {
            return feedReader;
        }

        protected override void Parse(XmlReader feedReader)
        {
        }

        protected override FeedItem ParseItem(XmlReader feedReader)
        {
            return null;
        }
    }
}
