using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Threading;

namespace MSIS
{
    /// <summary>
    /// Application entrance class. Initializes  
    /// </summary>
    static class PProgram
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [MTAThread]
        static void mMain()
        {
            // Load splash screen here

            // initialize data
            Data.Init();

            MainForm main = new MainForm();
            Screens.Main = main;

            // pre-load forms
            Screens.Init();

            // Initialize download queue and timer
            // This should be called after the main screen is initialized
            //   since its code assumes the main screen is already instantiated
            Net.Init();

            // open main screen
            Application.Run(main);
        }
    }
}