﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MSIS.webservices.ntnuemail;

namespace MSIS
{
    public partial class InboxForm : Form
    {
        EmailUser usr = null;
        int start, end, total;
        public InboxForm() { }
        public InboxForm(string[] inb, string id, string pa)
        {
            InitializeComponent();
            usr = new EmailUser();
            usr.EID = id;
            usr.EPassword = pa;
            namelbl.Text = "Welcome:"+id;
            FillMyTreeView(inb);
            this.KeyDown += new KeyEventHandler(Treeview_KeyDown);
        }

        private void InboxForm_Load(object sender, EventArgs e)
        {

        }
        private void FillMyTreeView(string[] inb)
        {


            // Display a wait cursor while the TreeNodes are being created.
            Cursor.Current = Cursors.WaitCursor;

            // Suppress repainting the TreeView until all the objects have been created.
            treeViewInbox.BeginUpdate();

            treeViewInbox.ShowLines = true;
            treeViewInbox.ShowPlusMinus = true;
            treeViewInbox.ShowRootLines = true;

            // Clear the TreeView each time the method is called.
            treeViewInbox.Nodes.Clear();

            // Set the imagelist
            treeViewInbox.ImageList = this.imageList1;
            // Set the default image for all nodes
            treeViewInbox.ImageIndex = 0;
            treeViewInbox.Nodes.Add("Mail Account");
            NtnuEmailService tc = new NtnuEmailService();
            int[] mcount = tc.MessageCounts(usr.EID,usr.EPassword);
            total = mcount[1];
            // Add the nodes
            for (int j = 0; j < inb.Length; j++)
            {
                if (inb[j] != null)
                    treeViewInbox.Nodes[0].Nodes.Add(inb[j]);

            }

            //treeViewInbox.Nodes.Add("My Mail");
            treeViewInbox.Nodes[0].Nodes[0].Nodes.Add("Recent(" + mcount[2] + ")");
            treeViewInbox.Nodes[0].Nodes[0].Nodes.Add("Unread(" + mcount[0] + ")");
            treeViewInbox.Nodes[0].Nodes[0].Nodes.Add("Total(" + mcount[1] + ")");
            //treeViewInbox.Nodes.Add("My Games");

            // Set a specific node image
            treeViewInbox.Nodes[0].ImageIndex = 1;
            treeViewInbox.Nodes[0].SelectedImageIndex = 1;
            //treeViewInbox.Nodes[2].ImageIndex = 2;
            //treeViewInbox.Nodes[2].SelectedImageIndex = 2;
            //treeViewInbox.Nodes[4].ImageIndex = 3;
            //treeViewInbox.Nodes[4].SelectedImageIndex = 3;

            treeViewInbox.ExpandAll();



            // Reset the cursor to the default for all controls.
            Cursor.Current = Cursors.Default;

            // Begin repainting the TreeView.
            treeViewInbox.EndUpdate();
        }
        private void Treeview_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Back)
            {
                return;
            }
            else
                base.OnKeyDown(e);
        }

        private void menuItem5_Click(object sender, EventArgs e)
        {
            EMessages[] emsgs= null;
            Cursor.Current = Cursors.WaitCursor;
            NtnuEmailService tc = new NtnuEmailService();
            emsgs = tc.GetEmail(usr.EID, usr.EPassword, total);
            start = total-1;
            //end = 15;
            Cursor.Current = Cursors.Default;
            new InboxList(emsgs,start, total, usr.EID,usr.EPassword).ShowDialog();
        }

        private void menuItem4_Click(object sender, EventArgs e)
        {
            new Compose(usr.EID).ShowDialog();
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            EMessages[] emsgs = null;
            Cursor.Current = Cursors.WaitCursor;
            NtnuEmailService tc = new NtnuEmailService();
            emsgs = tc.GetEmail(usr.EID, usr.EPassword, total);
            start = total - 1;
            //end = 15;
            Cursor.Current = Cursors.Default;
            new InboxList(emsgs, start, total, usr.EID, usr.EPassword).ShowDialog();

        }

        private void pictureBox2_Click(object sender, EventArgs e)
        {
            new Compose(usr.EID).ShowDialog();
        }

    }
}