﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using aspNetIMAP;
using aspNetMime;
using aspNetEmail;
using Twitterizer.Framework;

/// <summary>
/// Summary description for NtnuEmailService
/// </summary>
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
// [System.Web.Script.Services.ScriptService]
public class NtnuEmailService : System.Web.Services.WebService {

    string srv = "imap.stud.ntnu.no";
    string msrv = "smtp.stud.ntnu.no";
    
    IMAP4 imap = null;
    public NtnuEmailService () {
        //imap = new IMAP4(srv);
        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }
    [WebMethod]
    public string MailLogin(string id, string pass) {
        string msg = null;
        try
        {
            imap = new IMAP4(srv);
            imap.Login(id, pass);
            AdvancedIntellect.Ssl.SslSocket ssl = new AdvancedIntellect.Ssl.SslSocket();
            imap.LoadSslSocket(ssl);
            imap.Port = 993; //IMAP Ssl port
        }
        catch (IMAPLoginException e) {
            msg = "Invalid Id/Password";
        }

        bool r=imap.IsAuthenticated;
        if (r)
            msg = "true";
        imap.Disconnect();
        return msg;
    }
    [WebMethod]
    public string[] FolderList(string id, string pa) {
        imap = new IMAP4(srv);
        AdvancedIntellect.Ssl.SslSocket ssl = new AdvancedIntellect.Ssl.SslSocket();
       imap.LoadSslSocket(ssl);
       imap.Port = 993; //IMAP Ssl port


        imap.Login(id, pa);
        MailFolderCollection mfc = imap.FolderList();
        
        MailFolder[] folders = mfc.ToArray();
        string[] fnames = new string[folders.Length];
        int i = 0;
        foreach (MailFolder f in folders)
        {
            fnames[i++] = f.Name;
        }

        imap.Disconnect();
        return fnames;
    }
    [WebMethod]
    public int[] MessageCounts(string id, string pa)
    {
        IMAP4 imap = new IMAP4(srv);
        
        AdvancedIntellect.Ssl.SslSocket ssl = new AdvancedIntellect.Ssl.SslSocket();
        imap.LoadSslSocket(ssl);
        imap.Port = 993; //IMAP Ssl port


        imap.Login(id, pa);
        int unr=0, rec=0;
        MailFolder mf = imap.SelectFolder("INBOX");
        MessageClient mc = mf.MessageClient;
        for (int i = 1; i < mf.MessageCount; i++) {
            if (!mc.IsRead(i, IndexType.Ordinal)) 
                unr++;
            
            if (mc.IsRecent(i, IndexType.Ordinal))
                rec++;
        }
        int[] msgs = new int[3];
        msgs[0] = unr;
        msgs[1] = mf.MessageCount;
        msgs[2] = rec;

                 
        return msgs;

    }
    [WebMethod]
    public EMessages[] GetEmail(string eid, string pa, int temp)
    {
        Envelope env = new Envelope();
        //int temp = 0;
        IMAP4 imap = new IMAP4(srv);
       AdvancedIntellect.Ssl.SslSocket ssl = new AdvancedIntellect.Ssl.SslSocket();
       imap.LoadSslSocket(ssl);
       imap.Port = 993; //IMAP Ssl port


        imap.Login(eid, pa);
       // MailFolder mf = imap.OpenFolder("inbox");
        MailFolder mf = imap.SelectInbox();
        //temp = mf.CurrentMessageCount();
        EMessages[] emails = new EMessages[temp]; 
        for (int c = 0; c < temp; c++)
        {
            env = mf.FetchClient.Envelope(c + 1);
           // FastItem item = mf.FetchClient.Fast(c+1, IndexType.Ordinal);
            MessageClient mc = mf.MessageClient;

            //get the flags of the first message 
            FlagCollection fc = mc.Flags(c+1);
            emails[c] = new EMessages();
            
           if (fc != null)
           {
               foreach (Flag f in fc)
               {

                   if (f.Value.Equals("\\Seen"))
                       emails[c].Eread = true;

               }
           }

            emails[c].Subject = env.Subject;
            emails[c].From = env.From;
            
        }
        imap.Disconnect();
        return emails;
    }
    [WebMethod]
    public string ShowMail(int ind, string eid, string pa)
    {
        IMAP4 imap = new IMAP4(srv);
        AdvancedIntellect.Ssl.SslSocket ssl = new AdvancedIntellect.Ssl.SslSocket();
        imap.LoadSslSocket(ssl);
        imap.Port = 993; //IMAP Ssl port
        imap.Login(eid, pa);
        //string mailtext = null;
        MailFolder mf = imap.SelectInbox();
        MimeMessage mime = mf.FetchClient.Message(ind, IndexType.Ordinal, false);
        MessageClient mc = mf.MessageClient;
        mc.MarkAsRead(ind);
        imap.Disconnect();


       // mailtext = Regex.Replace(mailtext, "(<.*?>' ')", "");


        return mime.MainBody;
    }
    [WebMethod]
    public bool SendEmail(string[] fields, string from)
    {

        EmailMessage msg = new EmailMessage();
        msg.Server = msrv;
        msg.FromAddress = from+"@stud.ntnu.no";
        msg.To = fields[0];
        msg.Subject = fields[1];
        msg.Body = fields[2];

        if (msg.Send())

            return true;

        else

            return false;

    }
    [WebMethod]
    public bool logout() {

        return imap.Disconnect();
    }
    [WebMethod]
    public string SetStatus(string msg, string id, string pas)
    {
       Twitter t = new Twitter(id, pas);
        TwitterStatus ts = t.Status.Update(msg);
        return "Status is updated";
    }
    
}

